%% AC on (small) sphere: eigenfunctions spherical harmonics, dim(ker)=2l+1, 
% with eigenfunctions pairwise related by spatial shifts (sin(mx) and cos(mx)). 
% hence, use aux.ali to reduce dim(ker) to l+1 in qswibra(even l) and cswibra (odd l) 
close all; keep pphome; 
%% init and trivial branch 
p=[]; e=0.125; k0=0.1; ga=1; R=1; bpstyle=4; m=11; s=0; 
cut=[-2 0 -2]; par=[R k0 e ga s m]; % s=speed for x-PC, 
lx=pi; del=5e-2; ly=pi/2-del; nr=8; 
nx=11; ny=8; ref=1; odir='h1'; 
p=cpinit(p,lx,ly,nx,ny,nr,par,ref,bpstyle,cut); 
p=setfn(p,odir); 
%%
p=cont(p,20);
%%
p=swibra(odir,'bpt1','b1',0.05);  p.nc.tol=1e-6; % run with poor tol  
p.nc.intol=-5e-3; p.nc.dsmax=0.2; p=cont(p,22); % relax instab. tolerance 
p.nc.intol=-5e-6; p.nc.dsmax=0.1; p=cont(p,15); % tighten instab.tol, reduce max ds 
%%
fnr=3; figure(3); clf; c=7; ax=1; c=9; ax=2; %c=15; ax=0; 
plotbra('h1','pt20',fnr,c); 
plotbra('b1','bpt1',fnr,c,'cl','b','lab',[5 25], 'lp', 37); 
xlabel('m'); 
switch ax;
    case 1; axis([12 16 0.4 0.9]); ylabel('max(u)'); 
    case 2; axis([12 16 1.628 1.683]); ylabel('max(w)'); 
end
%%
plotsol('b1','pt5'); pause;  plotsol('b1','pt25'); 
%% check the threefold bif 
aux=[]; aux.m=3; aux.besw=0; p0=cswibra(odir,'bpt1',aux); pause 
%%
aux.hasker=1; aux.ali=[1 3]; aux.besw=1; aux.isotol=1e-2; p0=cswibra(p0,aux);
%% cont other orientation with PC, somewhat problematic for poor meshes! 
p=seltau(p0,1,'b1b',3); p.usrlam=[]; p.nc.tol=1e-6; p.nc.dsmax=0.4; 
p.nc.intol=-5e-3; p=conpc(p,-0.05,2,20); 
%%   aux. stuff ... 
[Gu, Gn]=jaccheck(p); Gd=abs(Gu-Gn); em=max(max(Gd)); 
figure(10); clf; Ge=(Gd>em/5); spy(Ge)
%%
um=0.8; wm=1.65; wm*4/3*pi+4*pi*um
