%% commands for SH 2nd order sys on rect. for hexagons
keep pphome; close all; p=[]; 
%% init and zero-branch 
p=[]; lx=2*pi; nx=round(6*lx); ly=lx; dir='sq'; ndim=2; lam=-0.001; nu=0; 
par=[lam; nu; 0; 0];  % s1,s2 for PC 
sw.ref=0; sw.sym=2; p=shinit(p,nx,lx,ly,ndim,par,sw); huclean(p); p=setfn(p,dir); 
p.sol.ds=0.005; p.nc.dsmin=0.005; p.sol.dsmax=0.02; 
p.file.smod=10; p.sw.bifcheck=2; p=cont(p,25); 
%%  BP1, stripes and spots 
aux=[]; aux.m=4; aux.besw=0;  
aux.ali=[2 4]; aux.besw=1; % 'active' list, first comment out this line 
p0=cswibra(dir,'bpt1',aux); p0.sw.bifcheck=2; p0.nc.tol=1e-6; p0.nc.dsmax=0.11; 
%% horizontal stripes, 3 initial steps, then switch on PC in y 
p=seltau(p0,1,'sq1s',3); p.sol.ds=0.05; p=cont(p,3); p=qyon(p); p=cont(p,20); 
%% spots, need both PCs, and pmcont rather than cont
p=seltau(p0,2,'sq1sp',3); p.sol.ds=0.1; p=cont(p,3); p=qxyon(p); p=pmcont(p,20); 
%%  BP2, oblique stripes and spots 
aux.m=8;  aux.besw=0; aux.ali=[]; aux.isotol=1e-6; 
aux.ali=[1 4 6 7]; aux.besw=1; %aux.ali=[1 3 5 7]; aux.besw=1;
p0=cswibra(dir,'bpt2',aux); 
p0.nc.tol=1e-6;  p0.nc.dsmax=0.1; 
%% 4 types of spots spots
p=seltau(p0,1,'sq2sp1',3); p.sol.ds=0.02; p=cont(p,5); p=qxyon(p); p=cont(p,25); 
p=seltau(p0,2,'sq2sp2',3); p.sol.ds=0.02; p=cont(p,5); p=qxyon(p); p=cont(p,25); 
p=seltau(p0,3,'sq2sp3',3); p.sol.ds=0.02; p=cont(p,5); p=qxyon(p); p=cont(p,25); 
p=seltau(p0,4,'sq2sp4',3); p.sol.ds=0.02; p=cont(p,5); p=qxyon(p); p=cont(p,25); 
%p=gentau(p0,[0 0 1],'sq2sp',3); p.sol.ds=0.02; p=cont(p,5); p=qxyon(p); p=cont(p,25); 
%%  BP3, 
aux=[]; aux.m=4;  aux.besw=0; aux.ali=[]; aux.isotol=1e-4; 
aux.ali=[1 4]; aux.besw=1; 
p0=cswibra(dir,'bpt3',aux);  p0.nc.dsmax=0.11; 
%% (obl.) stripes 
p=seltau(p0,3,'sq3s',3); p.sol.ds=0.02; p=cont(p,5); p=qyon(p); p=cont(p,25); 
%% spots
p=seltau(p0,1,'sq3sp',3); p.sol.ds=0.02; p=cont(p,5); p=qxyon(p); p=cont(p,25); 
%% BD-plots 
fnr=3; figure(fnr); cmp=5; clf; 
plotbra('sq',fnr,cmp,'cl','k','lsw',0); plotbra('sq1s',fnr,cmp,'cl','b'); 
plotbra('sq1sp',fnr,cmp,'cl','r'); plotbra('sq2s',fnr,cmp,'cl',p2pc('b2'));
plotbra('sq2sp',fnr,cmp,'cl',p2pc('r1')); plotbra('sq3s',fnr,cmp,'cl',p2pc('b3')); 
 plotbra('sq3sp',fnr,cmp,'cl',p2pc('o1')); 
axis([0 1.05 0 0.9]); box on;
title('\nu=0'); xlabel('\lambda'), ylabel('max(|u|)'); set(gca,'XTick',[0 0.5 1]); 
%% soln plots 
psol('sq1s','pt15'); pause; psol('sq1sp','pt19'); pause; 
psol('sq2s','pt24'); pause; psol('sq2sp','pt24'); pause; 
psol('sq3s','pt20'); pause; psol('sq3sp','pt21');
%% with fourier 
d='sq2sp'; pt='pt10'; p=loadp(d,pt); plotsol(p); fouplot(p,10,1,[3 5],[d '/' pt],1); 