function [sol,s1]=cpsolver(solinit,p,arc)
% cpsolver: wrapper for solving canonical-path problems by mtom or cpbvpnew
s1=p.ocopt.s1;
if arc==0 % invert arclength-continuation back to natural continuation on recalls
    solinit.par=solinit.par(1);
    if isfield(p.ocopt,'parm1') && length(p.ocopt.parm1)>length(solinit.par) % adapted stored parameters for secant
        p.ocopt.parm1=p.ocopt.parm1(1:length(p.cp.par));
    end
end
if arc==1;  p.ocopt.arc=1; p.tomopt.F=@NTwrapf; p.tomopt.BC=@NTwrapbce; 
    p.tomopt.FJacobian=@NTwrapfjace; p.tomopt.BCJacobian=@NTwrapbcjace;
else; p.ocopt.arc=0; p.tomopt.F=@NTwrapf; p.tomopt.BC=@NTwrapbc;
    p.tomopt.FJacobian=@NTwrapfjac; p.tomopt.BCJacobian=@NTwrapbcjac;
end
if p.ocopt.mtom==1
    tomopts=tomset('RelTol     ', 1e-3,'AbsTol     ', 1e-3, 'FJacobian  ', @NTwrapfjac,...
        'BCJacobian ', @NTwrapbcjac, 'ForceJAC   ', 'on', 'Order      ', 2, 'Stats      ', 'off', ...
        'Stats_step ', 'off', 'PrintG     ', 'off',  'IndexG     ', 1,  'Itnlmax    ', 10, 'Itlinmax   ', 10,...
        'Nmax       ', 100, 'Vectorized ', 'off',  'Monitor    ', 3,  'Stabcondpar', 'off');
    tomopts.vsw=0; fn=fieldnames(p.tomopt);
    for k=1:length(fn); tomopts.(fn{k})=p.tomopt.(fn{k}); end
    n=length(p.ocopt.u0);
    tomopts.M=[tomopts.M zeros(n,length(solinit.par));zeros(length(solinit.par),n) eye(length(solinit.par))];
    sol0.x=solinit.t; sol0.y=[solinit.u;repmat(solinit.par,1,length(solinit.t))];
    [sol1,info]=mtom(p.tomopt.F,p.tomopt.BC,sol0,tomopts,p.ocopt);
    sol.t=sol1.x; sol.u=sol1.y(1:n,:);
    sol.par=sol1.y(n+1:end,end);
    sol.err=sol1.err; sol.info=info;
else
    if arc==1; [sol,s1]=cpbvpnew(@NTmrhs,@NTcbcfe,solinit,p.tomopt,p.ocopt);
    else; [sol,s1]=cpbvpnew(@NTmrhs,@NTcbcf,solinit,p.tomopt,p.ocopt);  end
end